package coreElements;

import java.util.Properties;

/**
 * @author      Christopher Dragert
 * 
 * Stores all game settings set at the menu.
 * 
 */

public class PropertiesManager {
	
	Properties props;
	FBMain app;
	
	public PropertiesManager(FBMain main) {
		
		this.app = main;		
		
		props = new Properties();
//		try {
//			FileInputStream in = new FileInputStream("assign3.properties");
//			props.load(in);
//			in.close();
//		}
//		catch (Exception e) {
//			System.out.println(e.getMessage());
//			System.exit(0);
//		}
		
		//don't use props file
		
		props.setProperty("part", "3");
		props.setProperty("FPS","60");
		props.setProperty("n","10");
		props.setProperty("density","10");
		props.setProperty("braids","5");
		props.setProperty("show_braids","true");
		props.setProperty("show_velocity","true");
		props.setProperty("racers","200");
		props.setProperty("racerRespawn","true");
		props.setProperty("blockers","100");
		props.setProperty("blockersMove","true");
		

	}
	
	public void applyProperties() {
		//set for game
		Game.setProperties(
				Integer.parseInt(props.getProperty("part")),
				Integer.parseInt(props.getProperty("FPS")),
				Integer.parseInt(props.getProperty("racers")),
				Boolean.parseBoolean(props.getProperty("racerRespawn")),
				Integer.parseInt(props.getProperty("blockers")),
				Boolean.parseBoolean(props.getProperty("blockersMove")),	
				Integer.parseInt(props.getProperty("n")),
				Integer.parseInt(props.getProperty("density")),
				Integer.parseInt(props.getProperty("braids")));	
		
		//and for graphics.
		app.setShowBraids(Boolean.parseBoolean(props.getProperty("show_braids")));
		
		app.setShowVelocity(Boolean.parseBoolean(props.getProperty("show_velocity")));
	}
	
	public Properties getProperties() {
		return props;
	}
	
	public void setProperties(Properties p) {
		props = p;
	}
}
