package gameElements;

import java.util.Stack;

import coreElements.Game;
import coreElements.Vector2d;

/**
 * @author      Christopher Dragert
 * 
 * Blockers are game characters that seek to prevent Racers from reaching the goal. Blockers are meant
 * to be moderately effective, impeding rather than preventing progress.
 * 
 */
public class Blocker extends Character {

	public static double max_v = 0;
	public static boolean move = false;
	
	public Blocker(double x, double y, Stack<GridCell> path) {
		p = new Vector2d(x,y);
		v = new Vector2d(0,0);
		F = new Vector2d(0,0);

		this.path = path;
	}
		
	@Override
	public void applyGoals() {

	}
	
	private Vector2d vBlock = new Vector2d(0,0);
	public void addBlockee(Character c, double nearness) {
		if (move) {
			vBlock.zero();
			vBlock.set(((c.p.x + c.v.x) - p.x)*0.5,(c.p.y + c.v.y) - p.y);
			
			vBlock.scale(100/(nearness*nearness));
			
			if (vBlock.magnitude() > 1) {
				vBlock = vBlock.getUnit();
				vBlock.scale(5);
			}
			addForce(vBlock);
		}
	}
	

	@Override
	public void update(double t) {
		if (move) {
			F.scale(0.5);
			
			v.x += F.x*t;
			v.y += F.y*t;
			
			if (v.magnitude() > max_v) {
				v = v.getUnit();
				v.scale(max_v);
			}
			
			double oldX = p.x;
			double oldY = p.y;
			
			p.x += v.x * t;
			//p.x += v.x * t + F.x/2*t*t;
			if (p.x <= 0) p.x = 1;
			if (p.x >= Game.WIDTH) p.x = Game.WIDTH-1;
			p.y += v.y * t;
			//p.y += v.y * t + F.y/2*t*t;
			if (p.y <= 0) p.y =1;
			if (p.y >= Game.HEIGHT) p.y = Game.HEIGHT-1;
			
			v.scale(0.1);
			if (v.magnitude() < 0.01) v.zero();
			
			if (!Game.getInstance().getMaze().getGridLocation(p.x, p.y).inMaze()) {
				p.x = p.x - 2 * (p.x-oldX);
				p.y = p.y - 2 * (p.y-oldY);
			}
		}
	}

}
