package gameElements;


/**
 * @author      Christopher Dragert
 * 
 * A gridcell in the maze.  Contains infomation on size and location, mapping the gridcell to the GUI.  
 * 
 */
public class GridCell {
	public int x;
	public int y;
	public int guiX;
	public int width;
	public int guiY;
	public int height;
	private boolean exit;
	private boolean inMaze;
	private boolean visited;
	public boolean braided;
	
	public GridCell(int x, int y, int guiX,int guiY, int width, int height) {
		this.x = x;
		this.y = y;
		this.guiX = guiX;
		this.guiY = guiY;
		this.width = width;
		this.height = height;
		exit = false;
		inMaze = false;
		braided = false;
		
	}
	
	public void setExit(boolean bool) {
		this.exit = bool;
	}
	
	public void putInMaze() {
		inMaze = true;
	}
	
	public boolean inMaze() {
		return inMaze;
	}
	
	public boolean isExit() {
		return exit;
	}
	
	public void setVisited(boolean visited) {
		this.visited = visited;
	}
	
	public boolean visited() {
		return visited;
	}
	
	public void setBraided() {
		braided = true;
	}
	
	public double distance(GridCell g) {
		return Math.sqrt((x-g.x)*(x-g.x)+
						 (y-g.y)*(y-g.y));
	}
	
	public String toString() {
		return (x + "," + y);
	}
}
