package gameElements;

import java.util.Vector;

/**
 * @author      Christopher Dragert
 * 
 * A node used by the AStar pathfinder.
 * 
 */
public class Node {
	
	private Node parent;
	private Vector<Node> children;
	private double g;
	private double h;
	private GridCell gc;
	
	public Node(Node parent, double g, double h, GridCell gc) {
		this.parent = parent;
		this.g = g;
		this.h = h;
		children = new Vector<Node>();
		this.gc = gc;
	}
	
	public double getG() {
		return g;
	}
	
	public double getH() {
		return h;
	}
	
	public GridCell getGridCell() {
		return gc;
	}

	public Vector<Node> getChildren() {
		return children;
	}

	public void addChild(Node child) {
		children.add(child);
	}
	
	public Node getParent() {
		return parent;
	}
		
}

